Imports System
Imports System.Runtime.InteropServices


Namespace WinUsbDemo
	'''<summary >
	' API declarations relating to device management (SetupDixxx and 
	' RegisterDeviceNotification functions).   
	''' </summary>

	Friend NotInheritable Partial Class DeviceManagement
		Friend NotInheritable Class NativeMethods

			Private Sub New()
			End Sub
			' from setupapi.h

			Friend Const DIGCF_PRESENT As Int32 = 2
			Friend Const DIGCF_DEVICEINTERFACE As Int32 = &H10

			Friend Structure SP_DEVICE_INTERFACE_DATA
				Friend cbSize As Int32
				Friend InterfaceClassGuid As Guid
				Friend Flags As Int32
				Friend Reserved As IntPtr
			End Structure

			Friend Structure SP_DEVICE_INTERFACE_DETAIL_DATA
				Friend cbSize As Int32
				Friend DevicePath As String
			End Structure

			Friend Structure SP_DEVINFO_DATA
				Friend cbSize As Int32
				Friend ClassGuid As Guid
				Friend DevInst As Int32
				Friend Reserved As Int32
			End Structure

			<DllImport("setupapi.dll", SetLastError := True)> _
			Friend Shared Function SetupDiCreateDeviceInfoList(ByRef ClassGuid As Guid, ByVal hwndParent As IntPtr) As IntPtr
			End Function

			<DllImport("setupapi.dll", SetLastError := True)> _
			Friend Shared Function SetupDiDestroyDeviceInfoList(ByVal DeviceInfoSet As IntPtr) As Int32
			End Function

			<DllImport("setupapi.dll", SetLastError := True)> _
			Friend Shared Function SetupDiEnumDeviceInterfaces(ByVal DeviceInfoSet As IntPtr, ByVal DeviceInfoData As IntPtr, ByRef InterfaceClassGuid As Guid, ByVal MemberIndex As Int32, ByRef DeviceInterfaceData As SP_DEVICE_INTERFACE_DATA) As Boolean
			End Function

			<DllImport("setupapi.dll", SetLastError := True, CharSet := CharSet.Auto)> _
			Friend Shared Function SetupDiGetClassDevs(ByRef ClassGuid As Guid, ByVal Enumerator As IntPtr, ByVal hwndParent As IntPtr, ByVal Flags As Int32) As IntPtr
			End Function

			<DllImport("setupapi.dll", SetLastError := True, CharSet := CharSet.Auto)> _
			Friend Shared Function SetupDiGetDeviceInterfaceDetail(ByVal DeviceInfoSet As IntPtr, ByRef DeviceInterfaceData As SP_DEVICE_INTERFACE_DATA, ByVal DeviceInterfaceDetailData As IntPtr, ByVal DeviceInterfaceDetailDataSize As Int32, ByRef RequiredSize As Int32, ByVal DeviceInfoData As IntPtr) As Boolean
			End Function
		End Class
	End Class
End Namespace
